set pktsHdim	100
set pktsWdim	10
set pktsW1dim	10

set top .expr
set thisgl [frame $top.fr -bd 2 -relief groove]

set prog1d [canvas $thisgl.pkts1 -width $pktsW1dim -height $pktsHdim]
set progla [label $thisgl.lab -text "*/*" -font $globFonts -width 9]
## set prog2d [canvas $thisgl.pkts -width $pktsWdim -height $pktsHdim]
pack $thisgl -fill both -expand 1
pack $prog1d -side top
pack $progla -side top
## pack $prog2d -side left

$prog1d create rectangle \
	0 0 $pktsW1dim $pktsHdim -fill bisque -outline bisque -width 0

proc prog_percent {percent} {
	global prog1d progla pktsHdim pktsW1dim totsize
	$prog1d create rectangle \
		0 [expr (1.0 - $percent) * $pktsHdim] \
		$pktsW1dim $pktsHdim -fill brown -outline brown -width 0
	set app [expr $totsize * $percent]
	set pr [format "%.0fkB/\n%.0fkB" $app $totsize]
	$progla configure -text "$pr"
}

proc pkts_init {B k fsize psize} {
	global prog2d
	global pktsHfact pktsWfact pktsHdim pktsWdim
	global pktsB pktsk pktsHave pktsDups
	global pktssize filesize totsize
#	puts "#### init with B= $B and k= $k"
##	$prog2d delete all
	set pktsHfact [expr ${pktsHdim}.0/$B]
	set pktsWfact [expr ${pktsWdim}.0/$k]
	set pktsk	$k
	set pktsB	$B
	set pktssize	$psize
	set filesize	$fsize
	set totsize	[expr $k * $B * $psize / 1024.0]
#	puts "#### init have $B $k $pisize $fsize $totsize"
	for {set i 0} {$i < $B} {incr i} {
		set pktsHave($i)	0
		set pktsDups($i)	0
	}
}

proc pkts_have_dup {B more} {
	global prog2d

	return

	$prog2d create rectangle \
		[expr $pktsDups($B) * $pktsWfact] \
		[expr $B * $pktsHfact] \
		[expr ($pktsDups($B)+$more) * $pktsWfact] \
		[expr ($B+1) * $pktsHfact] \
		-fill red -outline red -width 0]
	set pktsDups($B) [expr $pktsDups($B) + $more]
}

proc pkts_have_more {B more} {
	global prog2d
	global pktsk pktsHave
	global pktsHfact pktsWfact pktsHdim pktsWdim

#	puts "#### enter with $B : $pktsHave($B)"

	return

	set app [expr $pktsk - ($pktsHave($B) + $more)]
	if {$app >= 0} {
		set less 0
	} elseif {$app > -$more} {
		set more [expr $more + $app]
		set less $app
	} else {
		set less [expr - $more]
		set more 0
	}
	if {$more > 0} {
		set thisid [$prog2d create rectangle \
			[expr $pktsHave($B) * $pktsWfact] \
			[expr $B * $pktsHfact] \
			[expr ($pktsHave($B)+$more) * $pktsWfact] \
			[expr ($B+1) * $pktsHfact] \
			-fill green -outline green -width 0]
		$prog2d lower  $thisid
		set pktsHave($B) [expr $pktsHave($B) + $more]
	}
	if {$less < 0} {
		$prog2d create rectangle \
			[expr (2 * $pktsk - ($pktsHave($B) - $less)) * $pktsWfact] \
			[expr $B * $pktsHfact] \
			[expr (2 * $pktsk - $pktsHave($B)) * $pktsWfact] \
			[expr ($B+1) * $pktsHfact] \
			-fill yellow -outline yellow -width 0
		set pktsHave($B) [expr $pktsHave($B) - $less]
		set app [expr 2 * $pktsk - $pktsHave($B)]
#		puts "####  have $less for $B ($app)"
	}
#	puts "#### exit with $B : $pktsHave($B) (less = $less)"
}

